#ifndef _in_DummyBrowser_h
#define _in_DummyBrowser_h

#include "IWContainerCallBack.h"


/////////////////////////////////////////////////////////////////////////////
// CDummyBrowser
//
class ATL_NO_VTABLE CDummyBrowser : 
  public CComObjectRootEx<CComMultiThreadModel>,
  public IDispatchImpl<IWebBrowserApp, &IID_IWebBrowserApp, &LIBID_MSHTML>
{
public:
        CDummyBrowser() {
          pDocInstance = NULL;
        };
        virtual ~CDummyBrowser() {};

BEGIN_COM_MAP(CDummyBrowser)
        // IE web browser interface
        COM_INTERFACE_ENTRY(IWebBrowserApp)
        COM_INTERFACE_ENTRY(IWebBrowser)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IWebBrowserApp)
END_COM_MAP()

  CIEHtmlDocumentInstance *pDocInstance;

// IWebBrowser implementation
  virtual HRESULT STDMETHODCALLTYPE GoBack(void)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE GoForward(void)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE GoHome(void)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE GoSearch(void)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE Navigate(BSTR URL, VARIANT __RPC_FAR *Flags, VARIANT __RPC_FAR *TargetFrameName, VARIANT __RPC_FAR *PostData, VARIANT __RPC_FAR *Headers)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE Refresh(void)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE Refresh2(VARIANT __RPC_FAR *Level)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE Stop( void)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Application(IDispatch __RPC_FAR *__RPC_FAR *ppDisp)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Parent(IDispatch __RPC_FAR *__RPC_FAR *ppDisp)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Container(IDispatch __RPC_FAR *__RPC_FAR *ppDisp)
  {
    if (!ppDisp) return E_INVALIDARG;
    IWContainerCallBackInstance *pContainerCallBack;
    IWContainerCallBackInstance::CreateInstance(&pContainerCallBack);
    pContainerCallBack->AddRef();
    return pContainerCallBack->QueryInterface(IID_IDispatch,(void**)ppDisp);
  }

  virtual HRESULT STDMETHODCALLTYPE get_Document(IDispatch __RPC_FAR *__RPC_FAR *ppDisp)
  {
    if (!ppDisp) return E_INVALIDARG;
    *ppDisp=NULL;
    if (!pDocInstance) return E_UNEXPECTED;
    return pDocInstance->QueryInterface(IID_IDispatch, (void**)ppDisp);
  }

  virtual HRESULT STDMETHODCALLTYPE get_TopLevelContainer(VARIANT_BOOL __RPC_FAR *pBool)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Type(BSTR __RPC_FAR *Type)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Left(long __RPC_FAR *pl)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_Left(long Left)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Top(long __RPC_FAR *pl)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_Top(long Top)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Width(long __RPC_FAR *pl)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_Width(long Width)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Height(long __RPC_FAR *pl)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_Height(long Height)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_LocationName(BSTR __RPC_FAR *LocationName)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_LocationURL(BSTR __RPC_FAR *LocationURL)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Busy(VARIANT_BOOL __RPC_FAR *pBool)
  { return E_NOTIMPL; }


// IWebBrowserApp implementation

  virtual HRESULT STDMETHODCALLTYPE Quit(void)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE ClientToWindow(int __RPC_FAR *pcx, int __RPC_FAR *pcy)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE PutProperty(BSTR Property, VARIANT vtValue)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE GetProperty(BSTR Property, VARIANT __RPC_FAR *pvtValue)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Name(BSTR __RPC_FAR *Name)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_HWND(long __RPC_FAR *pHWND)
  {
    if (!pHWND) return E_INVALIDARG;
    *pHWND=0;
    return S_OK;
  }

  virtual HRESULT STDMETHODCALLTYPE get_FullName(BSTR __RPC_FAR *FullName)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Path(BSTR __RPC_FAR *Path)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_Visible(VARIANT_BOOL __RPC_FAR *pBool)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_Visible(VARIANT_BOOL Value)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_StatusBar(VARIANT_BOOL __RPC_FAR *pBool)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_StatusBar(VARIANT_BOOL Value)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_StatusText(BSTR __RPC_FAR *StatusText)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_StatusText(BSTR StatusText)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_ToolBar(int __RPC_FAR *Value)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_ToolBar(int Value)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_MenuBar(VARIANT_BOOL __RPC_FAR *Value)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_MenuBar(VARIANT_BOOL Value)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE get_FullScreen(VARIANT_BOOL __RPC_FAR *pbFullScreen)
  { return E_NOTIMPL; }

  virtual HRESULT STDMETHODCALLTYPE put_FullScreen(VARIANT_BOOL bFullScreen)
  { return E_NOTIMPL; }

};

typedef CComObject<CDummyBrowser> CDummyBrowserInstance;


#endif
