/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 * 
 * Author:
 *   Adam Lock <adamlock@netscape.com>
 *
 * Contributor(s): 
 */
#include "stdafx.h"
#include "IEHtmlNode.h"
#include "nsIDOMNode.h"
#include "int\stdImplementation.h"

CIEHtmlNode::CIEHtmlNode()
{
        m_pIDOMNode = nsnull;
        m_pIDispParent = NULL;
}

CIEHtmlNode::~CIEHtmlNode()
{
        SetDOMNode(nsnull);
}

HRESULT CIEHtmlNode::SetParentNode(IDispatch *pIDispParent)
{
        m_pIDispParent = pIDispParent;
        return S_OK;
}

HRESULT CIEHtmlNode::SetDOMNode(nsIDOMNode *pIDOMNode)
{
        if (m_pIDOMNode)
        {
                m_pIDOMNode->Release();
                m_pIDOMNode = nsnull;
        }
        
        if (pIDOMNode)
        {
                m_pIDOMNode = pIDOMNode;
                m_pIDOMNode->AddRef();
        }

        return S_OK;
}

HRESULT CIEHtmlNode::GetDOMNode(nsIDOMNode **pIDOMNode)
{
        if (pIDOMNode == NULL)
        {
                return E_INVALIDARG;
        }

        *pIDOMNode = nsnull;
        if (m_pIDOMNode)
        {
                m_pIDOMNode->AddRef();
                *pIDOMNode = m_pIDOMNode;
        }

        return S_OK;
}

HRESULT CIEHtmlNode::GetDOMElement(nsIDOMElement **pIDOMElement)
{
        if (pIDOMElement == NULL)
        {
                return E_INVALIDARG;
        }

        if (m_pIDOMNode == nsnull)
        {
                return E_NOINTERFACE;
        }

        *pIDOMElement = nsnull;
        m_pIDOMNode->QueryInterface(NS_GET_IID(nsIDOMElement), (void **) pIDOMElement);
        return (*pIDOMElement) ? S_OK : E_NOINTERFACE;
}

HRESULT CIEHtmlNode::GetIDispatch(IDispatch **pDispatch) {
  if (pDispatch == NULL) {
    return E_INVALIDARG;
  }
  if (!m_pIDOMNode) return E_UNEXPECTED;
//  return m_pIDOMNode->QueryInterface(IID_IDispatch, (void**) pDispatch);
  *pDispatch=(IDispatch*)m_pIDOMNode;
  return S_OK;
}

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_nodeType(long __RPC_FAR *p)
  SIB_NODE_GET_NUMERIC(GetNodeType,PRUint16)

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_parentNode(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p)
  SIB_NODE_GET_ELEMENT(GetParentNode,nsIDOMNode)

HRESULT STDMETHODCALLTYPE CIEHtmlNode::hasChildNodes(VARIANT_BOOL __RPC_FAR *p)
  SIB_NODE_GET_NUMERIC(HasChildNodes,PRBool)

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_childNodes(IDispatch __RPC_FAR *__RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_attributes(IDispatch __RPC_FAR *__RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::insertBefore(IHTMLDOMNode __RPC_FAR *newChild,
    VARIANT refChild,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *node)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::removeChild(
    IHTMLDOMNode __RPC_FAR *oldChild,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *node)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::replaceChild(
    IHTMLDOMNode __RPC_FAR *newChild,
    IHTMLDOMNode __RPC_FAR *oldChild,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *node)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::cloneNode( 
    VARIANT_BOOL fDeep,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *clonedNode)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::removeNode( 
    VARIANT_BOOL fDeep,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *removed)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::swapNode( 
    IHTMLDOMNode __RPC_FAR *otherNode,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *swappedNode)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::replaceNode( 
    IHTMLDOMNode __RPC_FAR *replacement,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *replaced)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::appendChild( 
    IHTMLDOMNode __RPC_FAR *newChild,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *node)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_nodeName( 
    BSTR __RPC_FAR *p)
  SIB_NODE_GET_BSTR(GetNodeName)

HRESULT STDMETHODCALLTYPE CIEHtmlNode::put_nodeValue(VARIANT p)
  SIB_NODE_PUT_VARIANT_STR(SetNodeValue)

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_nodeValue(VARIANT __RPC_FAR *p)
  SIB_NODE_GET_VARIANT_STR(GetNodeValue)

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_firstChild(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p)
  SIB_NODE_GET_ELEMENT(GetFirstChild,nsIDOMNode)

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_lastChild(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p)
  SIB_NODE_GET_ELEMENT(GetLastChild,nsIDOMNode)

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_previousSibling(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p)
{
  if (!m_pIDOMNode) {
    NG_ASSERT(0);
    return E_UNEXPECTED;
  }
  CIEHtmlNode *pElementInstance = NULL;
  nsIDOMNode *pElement = NULL;
  if (FAILED(m_pIDOMNode->GetPreviousSibling(&pElement))) {
    NG_ASSERT(0);
    return E_UNEXPECTED;
  }
  *p=NULL;

  if (!pElement) return S_OK;

  if (SibTranslateCIEHTMLElement(pElement, &pElementInstance)) {
    pElement->Release();
//    pElementInstance->AddRef();
    HRESULT rc =  pElementInstance->QueryInterface(IID_IHTMLDOMNode,(void**) p);
    NG_ASSERT(rc==S_OK);
    return rc;
  }

  NG_ASSERT(0);
  return E_OUTOFMEMORY;
}

//  SIB_NODE_GET_ELEMENT(GetPreviousSibling,nsIDOMNode)

HRESULT STDMETHODCALLTYPE CIEHtmlNode::get_nextSibling(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p)
{
  if (!m_pIDOMNode) {
    NG_ASSERT(0);
    return E_UNEXPECTED;
  }

  *p=NULL;

  CIEHtmlNode *pElementInstance = NULL;
  nsIDOMNode *pElement = NULL;
  if (FAILED(m_pIDOMNode->GetNextSibling(&pElement))) {
    NG_ASSERT(0);
    return E_UNEXPECTED;
  }

  if (!pElement) return S_OK;

  if (SibTranslateCIEHTMLElement(pElement, &pElementInstance)) {
    pElement->Release();
//    pElementInstance->AddRef();
    HRESULT rc =  pElementInstance->QueryInterface(IID_IHTMLDOMNode,(void**) p);
    NG_ASSERT(rc==S_OK);
    return rc;
  }

  NG_ASSERT(0);
  return E_OUTOFMEMORY;
}
//  SIB_NODE_GET_ELEMENT(GetNextSibling,nsIDOMNode)
