/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 * 
 * Author:
 *   Adam Lock <adamlock@netscape.com>
 *
 * Contributor(s): 
 */
#ifndef IEHTMLNODE_H
#define IEHTMLNODE_H

class CIEHtmlNode :     public CComObjectRootEx<CComSingleThreadModel>,
                        public IDispatchImpl<IHTMLDOMNode, &IID_IHTMLDOMNode, &LIBID_MSHTML>

{
protected:
  nsIDOMNode *m_pIDOMNode;
  IDispatch  *m_pIDispParent;

public:
  CIEHtmlNode();
protected:
  virtual ~CIEHtmlNode();
  typedef nsIDOMNode SIB_STD_CLASSNAME;

public:

BEGIN_COM_MAP(CIEHtmlNode)
  COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLDOMNode)
  COM_INTERFACE_ENTRY_IID(IID_IHTMLDOMNode, IHTMLDOMNode)
END_COM_MAP()

        virtual HRESULT SetDOMNode(nsIDOMNode *pIDOMNode);
        virtual HRESULT GetDOMNode(nsIDOMNode **pIDOMNode);
        virtual HRESULT GetDOMElement(nsIDOMElement **pIDOMElement);
        virtual HRESULT SetParentNode(IDispatch *pIDispParent);
        virtual HRESULT GetIDispatch(IDispatch **pDispatch);

  virtual HRESULT STDMETHODCALLTYPE get_nodeType(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_parentNode(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE hasChildNodes(VARIANT_BOOL __RPC_FAR *fChildren);
  virtual HRESULT STDMETHODCALLTYPE get_childNodes(IDispatch __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_attributes(IDispatch __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE insertBefore(IHTMLDOMNode __RPC_FAR *newChild,
    VARIANT refChild,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *node);
  virtual HRESULT STDMETHODCALLTYPE removeChild(
    IHTMLDOMNode __RPC_FAR *oldChild,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *node);
  virtual HRESULT STDMETHODCALLTYPE replaceChild(
    IHTMLDOMNode __RPC_FAR *newChild,
    IHTMLDOMNode __RPC_FAR *oldChild,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *node);
  virtual HRESULT STDMETHODCALLTYPE cloneNode( 
    VARIANT_BOOL fDeep,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *clonedNode);
  virtual HRESULT STDMETHODCALLTYPE removeNode( 
    VARIANT_BOOL fDeep,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *removed);
  virtual HRESULT STDMETHODCALLTYPE swapNode( 
    IHTMLDOMNode __RPC_FAR *otherNode,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *swappedNode);
  virtual HRESULT STDMETHODCALLTYPE replaceNode( 
    IHTMLDOMNode __RPC_FAR *replacement,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *replaced);
  virtual HRESULT STDMETHODCALLTYPE appendChild( 
    IHTMLDOMNode __RPC_FAR *newChild,
    IHTMLDOMNode __RPC_FAR *__RPC_FAR *node);
  virtual HRESULT STDMETHODCALLTYPE get_nodeName( 
    BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_nodeValue(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_nodeValue(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_firstChild(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_lastChild(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_previousSibling(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_nextSibling(IHTMLDOMNode __RPC_FAR *__RPC_FAR *p);

};

typedef CComObject<CIEHtmlNode> CIEHtmlNodeInstance;

#endif