#include "stdafx.h"
#include "IETextElement.h"
#include "nsIDOMText.h"

#include "int\stdImplementation.h"


HRESULT STDMETHODCALLTYPE CIETextElement::put_data(BSTR p)
{ 
  if (!p) return E_INVALIDARG;

  nsIDOMText *pNode = nsnull;
  if (FAILED(GetDOMNode((nsIDOMNode**)&pNode))) {
    NG_ASSERT(0);
    return E_UNEXPECTED;
  }
  nsString szValue(OLE2W(p));
  HRESULT rc = pNode->SetData(szValue);
  pNode->Release();
  return rc;
}


HRESULT STDMETHODCALLTYPE CIETextElement::get_data(BSTR __RPC_FAR *p)
{ 
  nsIDOMText *pNode = nsnull;
  if (FAILED(GetDOMNode((nsIDOMNode**)&pNode))) {
    NG_ASSERT(0);
    return E_UNEXPECTED;
  }
  nsString szData;
  HRESULT rc = pNode->GetData(szData);
  pNode->Release();
  USES_CONVERSION;
  *p = SysAllocString(W2COLE(szData.GetUnicode()));
  return rc;
}

HRESULT STDMETHODCALLTYPE CIETextElement::toString(BSTR __RPC_FAR *p) {
  return get_data(p);
}

HRESULT STDMETHODCALLTYPE CIETextElement::get_length(long __RPC_FAR *p)
{
  nsIDOMText *pNode = nsnull;
  if (FAILED(GetDOMNode((nsIDOMNode**)&pNode))) {
    NG_ASSERT(0);
    return E_UNEXPECTED;
  }
  PRUint32 nData;
  HRESULT rc = pNode->GetLength(&nData);
  pNode->Release();
  *p = nData;
  return rc;
}

HRESULT STDMETHODCALLTYPE CIETextElement::splitText(
  long offset,
  IHTMLDOMNode __RPC_FAR *__RPC_FAR *p)
  SIB_STD_NOTIMPL

/*
{
  CIETextElementInstance *pElementInstance = NULL;
  nsIDOMText *pElement = NULL;
  if (FAILED(SplitText(offset, &pElement))) return E_UNEXPECTED;
  *p=NULL;
  BSTR bsTagName = NULL;
  CIETextElementInstance::CreateInstance(&pElementInstance);

  pElementInstance->SetDOMNode(pElement);
  pElement->Release();
  pElementInstance->AddRef();
  return pElementInstance->QueryInterface(IHTMLDOMText,(void**) p);
}
*/        
