//
// Declaration of IHTMLFormElement
//

#ifndef _in_IHTMLFormElement_h
#define _in_IHTMLFormElement_h

// #include <atlbase.h>
#include "stdafx.h"
#include "IEHTMLElement.h"

class nsIDOMHTMLFormElement;

class CIHtmlFormElement: public CIEHtmlElement,
                         public IDispatchImpl<IHTMLFormElement, &IID_IHTMLFormElement, &LIBID_MSHTML>,
                         public IDispatchImpl<IHTMLFormElement2, &IID_IHTMLFormElement2, &LIBID_MSHTML>
{
public:
  CIHtmlFormElement() {
  };
protected:
  virtual ~CIHtmlFormElement() {
  };
  typedef nsIDOMHTMLFormElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlFormElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLFormElement2)
        COM_INTERFACE_ENTRY(IHTMLFormElement)
        COM_INTERFACE_ENTRY(IHTMLFormElement2)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

  virtual HRESULT STDMETHODCALLTYPE put_action(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_action(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_dir(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_dir(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_encoding(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_encoding(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_method(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_method(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_elements(IDispatch __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_target(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_target(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_name(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_name(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onsubmit(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onsubmit(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onreset(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onreset(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE submit(void);
  virtual HRESULT STDMETHODCALLTYPE reset(void);
  virtual HRESULT STDMETHODCALLTYPE put_length(long p);
  virtual HRESULT STDMETHODCALLTYPE get_length(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get__newEnum(IUnknown __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE item(
    VARIANT name,
    VARIANT index,
    IDispatch __RPC_FAR *__RPC_FAR *pdisp);
  virtual HRESULT STDMETHODCALLTYPE tags(
    VARIANT tagName,
    IDispatch __RPC_FAR *__RPC_FAR *pdisp);
        

//
// IHTMLFormElement2
//

  virtual HRESULT STDMETHODCALLTYPE put_acceptCharset(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_acceptCharset(BSTR __RPC_FAR *p);
  virtual /* [id] */ HRESULT STDMETHODCALLTYPE urns(
    VARIANT urn,
    IDispatch __RPC_FAR *__RPC_FAR *pdisp);
};
typedef CComObject<CIHtmlFormElement> CIHtmlFormElementInstance;

HRESULT WINAPI Sib_InputTypeFunc(void* pv, REFIID riid, LPVOID* ppv, DWORD dw);

class nsIDOMHTMLInputElement;

class CIHtmlInputElement:
  public CIEHtmlElement,
  public IDispatchImpl<IHTMLInputElement, &IID_IHTMLInputElement, &LIBID_MSHTML>,
  public IDispatchImpl<IHTMLInputButtonElement, &IID_IHTMLInputButtonElement, &LIBID_MSHTML>,
  public IDispatchImpl<IHTMLInputHiddenElement, &IID_IHTMLInputHiddenElement, &LIBID_MSHTML>,
  public IDispatchImpl<IHTMLInputTextElement, &IID_IHTMLInputTextElement, &LIBID_MSHTML>,
  public IDispatchImpl<IHTMLInputFileElement, &IID_IHTMLInputFileElement, &LIBID_MSHTML>,
  public IDispatchImpl<IHTMLOptionButtonElement, &IID_IHTMLOptionButtonElement, &LIBID_MSHTML>,
  public IDispatchImpl<IHTMLInputImage, &IID_IHTMLInputImage, &LIBID_MSHTML>
{
public:
  CIHtmlInputElement() {
  };
protected:
  virtual ~CIHtmlInputElement() {
  };
  typedef nsIDOMHTMLInputElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlInputElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLInputElement)
        COM_INTERFACE_ENTRY(IHTMLInputElement)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
        COM_INTERFACE_ENTRY_FUNC(IID_IHTMLInputButtonElement,  0, Sib_InputTypeFunc)
        COM_INTERFACE_ENTRY_FUNC(IID_IHTMLInputHiddenElement,  1, Sib_InputTypeFunc)
        COM_INTERFACE_ENTRY_FUNC(IID_IHTMLInputTextElement,    2, Sib_InputTypeFunc)
        COM_INTERFACE_ENTRY_FUNC(IID_IHTMLInputFileElement,    3, Sib_InputTypeFunc)
        COM_INTERFACE_ENTRY_FUNC(IID_IHTMLOptionButtonElement, 4, Sib_InputTypeFunc)
        COM_INTERFACE_ENTRY_FUNC(IID_IHTMLInputImage,          5, Sib_InputTypeFunc)
        COM_INTERFACE_ENTRY(IHTMLInputButtonElement)
        COM_INTERFACE_ENTRY(IHTMLInputHiddenElement)
        COM_INTERFACE_ENTRY(IHTMLInputTextElement)
        COM_INTERFACE_ENTRY(IHTMLInputFileElement)
        COM_INTERFACE_ENTRY(IHTMLOptionButtonElement)
        COM_INTERFACE_ENTRY(IHTMLInputImage)
END_COM_MAP()

  virtual HRESULT STDMETHODCALLTYPE put_type(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_type(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_value(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_value(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_name(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_name(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_status(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_status(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_disabled(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_disabled(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_form(IHTMLFormElement __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_size(long p);
  virtual HRESULT STDMETHODCALLTYPE get_size(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_maxLength(long p);
  virtual HRESULT STDMETHODCALLTYPE get_maxLength(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE select(void);

  virtual HRESULT STDMETHODCALLTYPE put_onchange(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onchange(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onselect(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onselect(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onload(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onload(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onerror(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onerror(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onabort(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onabort(VARIANT __RPC_FAR *p);
  

  virtual HRESULT STDMETHODCALLTYPE put_defaultValue(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_defaultValue(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_readOnly(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_readOnly(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE createTextRange(IHTMLTxtRange __RPC_FAR *__RPC_FAR *range);
  virtual HRESULT STDMETHODCALLTYPE put_indeterminate(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_indeterminate(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_defaultChecked(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_defaultChecked(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_checked(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_checked(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_border(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_border(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_vspace(long p);
  virtual HRESULT STDMETHODCALLTYPE get_vspace(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_hspace(long p);
  virtual HRESULT STDMETHODCALLTYPE get_hspace(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_alt(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_alt(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_src(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_src(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_lowsrc(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_lowsrc(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_vrml(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_vrml(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_dynsrc(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_dynsrc(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_readyState(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_complete(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_loop(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_loop(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_align(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_align(BSTR __RPC_FAR *p);

  virtual HRESULT STDMETHODCALLTYPE put_width(long p);
  virtual HRESULT STDMETHODCALLTYPE get_width(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_height(long p);
  virtual HRESULT STDMETHODCALLTYPE get_height(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_start(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_start(BSTR __RPC_FAR *p);
  //
  // Element-specific calls
  //
  // button hidden text file
  virtual HRESULT STDMETHODCALLTYPE put_status(VARIANT p);
  // button hidden text file
  virtual HRESULT STDMETHODCALLTYPE get_status(VARIANT __RPC_FAR *p);

};
typedef CComObject<CIHtmlInputElement> CIHtmlInputElementInstance;


class nsIDOMHTMLSelectElement;

class CIHtmlSelectElement: public CIEHtmlElement,
                           public IDispatchImpl<IHTMLSelectElement, &IID_IHTMLSelectElement, &LIBID_MSHTML>,
                           public IDispatchImpl<IHTMLSelectElement2, &IID_IHTMLSelectElement2, &LIBID_MSHTML>
{
public:
  CIHtmlSelectElement() {
  };
protected:
  virtual ~CIHtmlSelectElement() {
  };
  typedef nsIDOMHTMLSelectElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlSelectElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLSelectElement2)
        COM_INTERFACE_ENTRY(IHTMLSelectElement)
        COM_INTERFACE_ENTRY(IHTMLSelectElement2)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

  virtual HRESULT STDMETHODCALLTYPE put_size(long p);
  virtual HRESULT STDMETHODCALLTYPE get_size(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_multiple(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_multiple(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_name(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_name(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_options(IDispatch __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onchange(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onchange(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_selectedIndex(long p);
  virtual HRESULT STDMETHODCALLTYPE get_selectedIndex(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_type(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_value(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_value(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_disabled(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_disabled(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_form(IHTMLFormElement __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE add(
    IHTMLElement __RPC_FAR *element,
    VARIANT before);
  virtual HRESULT STDMETHODCALLTYPE remove(long index = -1);
  virtual HRESULT STDMETHODCALLTYPE put_length(long p);
  virtual HRESULT STDMETHODCALLTYPE get_length(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get__newEnum(IUnknown __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE item(
    VARIANT name,
    VARIANT index,
    IDispatch __RPC_FAR *__RPC_FAR *pdisp);
  virtual HRESULT STDMETHODCALLTYPE tags(
    VARIANT tagName,
    IDispatch __RPC_FAR *__RPC_FAR *pdisp);
//
// IHTMLSelectElement2
//
   virtual HRESULT STDMETHODCALLTYPE urns(
     VARIANT urn,
     IDispatch __RPC_FAR *__RPC_FAR *pdisp);

};
typedef CComObject<CIHtmlSelectElement> CIHtmlSelectElementInstance;

class nsIDOMHTMLOptionElement;

class CIHtmlOptionElement: public CIEHtmlElement,
                           public IDispatchImpl<IHTMLOptionElement, &IID_IHTMLOptionElement, &LIBID_MSHTML>
{
public:
  CIHtmlOptionElement() {
  };
protected:
  virtual ~CIHtmlOptionElement() {
  };
  typedef nsIDOMHTMLOptionElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlOptionElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLOptionElement)
        COM_INTERFACE_ENTRY(IHTMLOptionElement)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()
  virtual HRESULT STDMETHODCALLTYPE put_selected(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_selected(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_value(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_value(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_defaultSelected(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_defaultSelected(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_index(long p);
  virtual HRESULT STDMETHODCALLTYPE get_index(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_text(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_text(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_form(IHTMLFormElement __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_innerText(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_outerText(BSTR __RPC_FAR *p);
};
typedef CComObject<CIHtmlOptionElement> CIHtmlOptionElementInstance;


class nsIDOMHTMLTextAreaElement;

class CIHtmlTextAreaElement: public CIEHtmlElement,
                             public IDispatchImpl<IHTMLTextAreaElement, &IID_IHTMLTextAreaElement, &LIBID_MSHTML>
{
public:
  CIHtmlTextAreaElement() {
  };
protected:
  virtual ~CIHtmlTextAreaElement() {
  };
  typedef nsIDOMHTMLTextAreaElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlTextAreaElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLTextAreaElement)
        COM_INTERFACE_ENTRY_IID(IID_IHTMLTextAreaElement, IHTMLTextAreaElement)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()


  virtual HRESULT STDMETHODCALLTYPE get_type(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_value(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_value(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_name(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_name(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_status(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_status(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_disabled(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_disabled(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_form(IHTMLFormElement __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_defaultValue(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_defaultValue(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE select(void);
  virtual HRESULT STDMETHODCALLTYPE put_onchange(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onchange(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onselect(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onselect(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_readOnly(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_readOnly(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_rows(long p);
  virtual HRESULT STDMETHODCALLTYPE get_rows(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_cols(long p);
  virtual HRESULT STDMETHODCALLTYPE get_cols(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_wrap(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_wrap(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE createTextRange(
    IHTMLTxtRange __RPC_FAR *__RPC_FAR *range);

};
typedef CComObject<CIHtmlTextAreaElement> CIHtmlTextAreaElementInstance;


class nsIDOMHTMLFieldSetElement;

class CIHtmlFieldSetElement: public CIEHtmlElement,
                             public IDispatchImpl<IHTMLFieldSetElement, &IID_IHTMLFieldSetElement, &LIBID_MSHTML>
{
public:
  CIHtmlFieldSetElement() {
  };
protected:
  virtual ~CIHtmlFieldSetElement() {
  };
  typedef nsIDOMHTMLFieldSetElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlFieldSetElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLFieldSetElement)
        COM_INTERFACE_ENTRY_IID(IID_IHTMLFieldSetElement, IHTMLFieldSetElement)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

  virtual HRESULT STDMETHODCALLTYPE put_align(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_align(BSTR __RPC_FAR *p);

};
typedef CComObject<CIHtmlFieldSetElement> CIHtmlFieldSetElementInstance;


#endif