//
// Declaration of IHTMLFrame and related classes
//
#ifndef _in_IHTMLFrame_h
#define _in_IHTMLFrame_h

#include "stdafx.h"
#include "IEHTMLElement.h"

class nsIDOMHTMLFrameElement;
class nsIDOMHTMLFrameSetElement;
class nsIDOMHTMLIFrameElement;


class CIHtmlFrameElement: public CIEHtmlElement,
                          public IDispatchImpl<IHTMLFrameElement, &IID_IHTMLFrameElement, &LIBID_MSHTML>,
                          public IDispatchImpl<IHTMLFrameBase, &IID_IHTMLFrameBase, &LIBID_MSHTML>,
                          public IDispatchImpl<IHTMLWindow2, &IID_IHTMLWindow2, &LIBID_MSHTML>
{
public:
  CIHtmlFrameElement() {
  };
protected:
  virtual ~CIHtmlFrameElement() {
  };
  typedef nsIDOMHTMLFrameElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlFrameElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLFrameBase)
        COM_INTERFACE_ENTRY(IHTMLFrameElement)
        COM_INTERFACE_ENTRY(IHTMLFrameBase)
        COM_INTERFACE_ENTRY(IHTMLWindow2)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

public:
//
// IHTMLFrameElement
//
  virtual HRESULT STDMETHODCALLTYPE put_borderColor(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColor(VARIANT __RPC_FAR *p);
//
// IHTMLFrameBase
//
  virtual HRESULT STDMETHODCALLTYPE put_src(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_src(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_name(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_name(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_border(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_border(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_frameBorder(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_frameBorder(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_frameSpacing(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_frameSpacing(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_marginWidth(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_marginWidth(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_marginHeight(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_marginHeight(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_noResize(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_noResize(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_scrolling(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_scrolling(BSTR __RPC_FAR *p);
//
// IHTMLWindow2
//
  virtual HRESULT STDMETHODCALLTYPE get_frames(IHTMLFramesCollection2 __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_defaultStatus(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_defaultStatus(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_status(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_status(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE setTimeout(BSTR expression,
                                               long msec,
                                               VARIANT __RPC_FAR *language,
                                               long __RPC_FAR *timerID);
  virtual HRESULT STDMETHODCALLTYPE clearTimeout(long timerID);
  virtual HRESULT STDMETHODCALLTYPE alert(BSTR message = L"");
  virtual HRESULT STDMETHODCALLTYPE confirm(BSTR message,
                                            VARIANT_BOOL __RPC_FAR *confirmed);
  virtual HRESULT STDMETHODCALLTYPE prompt(BSTR message,
                                           BSTR defstr,
                                           VARIANT __RPC_FAR *textdata);
  virtual HRESULT STDMETHODCALLTYPE get_Image(IHTMLImageElementFactory __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_location(IHTMLLocation __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_history(IOmHistory __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE close(void);
  virtual HRESULT STDMETHODCALLTYPE put_opener(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_opener(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_navigator(IOmNavigator __RPC_FAR *__RPC_FAR *p);
//  virtual HRESULT STDMETHODCALLTYPE put_name(BSTR p);
//  virtual HRESULT STDMETHODCALLTYPE get_name(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_parent(IHTMLWindow2 __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE open(BSTR url,
                                         BSTR name,
                                         BSTR features,
                                         VARIANT_BOOL replace,
                                         IHTMLWindow2 __RPC_FAR *__RPC_FAR *pomWindowResult);
  virtual HRESULT STDMETHODCALLTYPE get_self(IHTMLWindow2 __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_top(IHTMLWindow2 __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_window(IHTMLWindow2 __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE navigate(BSTR url);
  virtual HRESULT STDMETHODCALLTYPE put_onfocus(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onfocus(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onblur(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onblur(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onload(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onload(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onbeforeunload(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onbeforeunload(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onunload(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onunload(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onhelp(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onhelp(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onerror(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onerror(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onresize(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onresize(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onscroll(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onscroll(VARIANT __RPC_FAR *p);

  virtual HRESULT STDMETHODCALLTYPE get_document(IHTMLDocument2 __RPC_FAR *__RPC_FAR *p);
  
  virtual HRESULT STDMETHODCALLTYPE get_event(IHTMLEventObj __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get__newEnum(IUnknown __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE showModalDialog(BSTR dialog,
                                                    VARIANT __RPC_FAR *varArgIn,
                                                    VARIANT __RPC_FAR *varOptions,
                                                    VARIANT __RPC_FAR *varArgOut);
  virtual HRESULT STDMETHODCALLTYPE showHelp(BSTR helpURL,
                                             VARIANT helpArg,
                                             BSTR features = L"");
  virtual HRESULT STDMETHODCALLTYPE get_screen(IHTMLScreen __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_Option(IHTMLOptionElementFactory __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE focus(void);
  virtual HRESULT STDMETHODCALLTYPE get_closed(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE blur(void);
  virtual HRESULT STDMETHODCALLTYPE scroll(long x, long y);
  virtual HRESULT STDMETHODCALLTYPE get_clientInformation(IOmNavigator __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE setInterval(BSTR expression,
                                                long msec,
                                                VARIANT __RPC_FAR *language,
                                                long __RPC_FAR *timerID);
  
  virtual HRESULT STDMETHODCALLTYPE clearInterval(long timerID);
  virtual HRESULT STDMETHODCALLTYPE put_offscreenBuffering(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_offscreenBuffering(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE execScript(BSTR code,
                                               BSTR language,
                                               VARIANT __RPC_FAR *pvarRet);
  virtual HRESULT STDMETHODCALLTYPE toString(BSTR __RPC_FAR *String);
  virtual HRESULT STDMETHODCALLTYPE scrollBy(long x, long y);
  virtual HRESULT STDMETHODCALLTYPE scrollTo(long x, long y);
  virtual HRESULT STDMETHODCALLTYPE moveTo(long x, long y);
  virtual HRESULT STDMETHODCALLTYPE moveBy(long x, long y);
  virtual HRESULT STDMETHODCALLTYPE resizeTo(long x, long y);
  virtual HRESULT STDMETHODCALLTYPE resizeBy(long x, long y);
  virtual HRESULT STDMETHODCALLTYPE get_external(IDispatch __RPC_FAR *__RPC_FAR *p);
//
// IHTMLFramesCollection2
//
  virtual HRESULT STDMETHODCALLTYPE item(VARIANT __RPC_FAR *pvarIndex,
                                         VARIANT __RPC_FAR *pvarResult);
  virtual HRESULT STDMETHODCALLTYPE get_length(long __RPC_FAR *p);
        

};

typedef CComObject<CIHtmlFrameElement> CIHtmlFrameElementInstance;


class CIHtmlFrameSetElement: public CIEHtmlElement,
                             public IDispatchImpl<IHTMLFrameSetElement, &IID_IHTMLFrameSetElement, &LIBID_MSHTML>,
                             public IDispatchImpl<IHTMLFrameSetElement2, &IID_IHTMLFrameSetElement2, &LIBID_MSHTML>
{
public:
  CIHtmlFrameSetElement() {
  };
protected:
  virtual ~CIHtmlFrameSetElement() {
  };
  typedef nsIDOMHTMLFrameSetElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlFrameSetElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLFrameSetElement)
        COM_INTERFACE_ENTRY(IHTMLFrameSetElement)
        COM_INTERFACE_ENTRY(IHTMLFrameSetElement2)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

public:
//
// IHTMLFrameSetElement
//
  virtual HRESULT STDMETHODCALLTYPE put_rows(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_rows(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_cols(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_cols(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_border(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_border(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColor(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColor(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_frameBorder(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_frameBorder(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_frameSpacing(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_frameSpacing(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_name(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_name(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onload(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onload(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onunload(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onunload(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onbeforeunload(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onbeforeunload(VARIANT __RPC_FAR *p);
//
// IHTMLFrameSetElement2
//
  virtual HRESULT STDMETHODCALLTYPE put_onbeforeprint(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onbeforeprint(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onafterprint(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onafterprint(VARIANT __RPC_FAR *p);
};
typedef CComObject<CIHtmlFrameSetElement> CIHtmlFrameSetElementInstance;


class CIHtmlIFrameElement: public CIEHtmlElement,
                           public IDispatchImpl<IHTMLIFrameElement, &IID_IHTMLIFrameElement, &LIBID_MSHTML>,
                           public IDispatchImpl<IHTMLIFrameElement2, &IID_IHTMLIFrameElement2, &LIBID_MSHTML>
{
public:
  CIHtmlIFrameElement() {
  };
protected:
  virtual ~CIHtmlIFrameElement() {
  };
  typedef nsIDOMHTMLIFrameElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlIFrameElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLIFrameElement)
        COM_INTERFACE_ENTRY(IHTMLIFrameElement)
        COM_INTERFACE_ENTRY(IHTMLIFrameElement2)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

public:
//
// IHTMLIFrameElement
//
  virtual HRESULT STDMETHODCALLTYPE put_vspace(long p);
  virtual HRESULT STDMETHODCALLTYPE get_vspace(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_hspace(long p);
  virtual HRESULT STDMETHODCALLTYPE get_hspace(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_align(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_align(BSTR __RPC_FAR *p);
//
// IHTMLIFrameElement2
//
  virtual HRESULT STDMETHODCALLTYPE put_height(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_height(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_width(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_width(VARIANT __RPC_FAR *p);

};
typedef CComObject<CIHtmlIFrameElement> CIHtmlIFrameElementInstance;

#endif