//
// Declaration of IHTMLTable and related classes
//
#ifndef _in_int_IHTMLTable_h
#define _in_int_IHTMLTable_h

#include "stdafx.h"
#include "IEHTMLElement.h"

struct IHTMLTableSection;
struct IHTMLTableCaption;

class nsIDOMHTMLTableElement;

class CIHtmlTableElement: public CIEHtmlElement,
                          public IDispatchImpl<IHTMLTable2, &IID_IHTMLTable2, &LIBID_MSHTML>,
                          public IDispatchImpl<IHTMLTable, &IID_IHTMLTable, &LIBID_MSHTML>
{
public:
  CIHtmlTableElement() {
  };
protected:
  virtual ~CIHtmlTableElement() {
  };
  typedef nsIDOMHTMLTableElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlTableElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLTable2)
        COM_INTERFACE_ENTRY(IHTMLTable)
        COM_INTERFACE_ENTRY(IHTMLTable2)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

  virtual HRESULT STDMETHODCALLTYPE put_cols(long p);
  virtual HRESULT STDMETHODCALLTYPE get_cols(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_border(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_border(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_frame(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_frame(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_rules(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_rules(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_cellSpacing(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_cellSpacing(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_cellPadding(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_cellPadding(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_background(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_background(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_bgColor(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_bgColor(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColor(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColor(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColorLight(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColorLight(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColorDark(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColorDark(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_align(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_align(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE refresh( void);
  virtual HRESULT STDMETHODCALLTYPE get_rows(IHTMLElementCollection __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_width(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_width(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_height(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_height(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_dataPageSize(long p);
  virtual HRESULT STDMETHODCALLTYPE get_dataPageSize(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE nextPage(void);
  virtual HRESULT STDMETHODCALLTYPE previousPage(void);
  virtual HRESULT STDMETHODCALLTYPE get_tHead(IHTMLTableSection __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_tFoot(IHTMLTableSection __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_tBodies(IHTMLElementCollection __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_caption(IHTMLTableCaption __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE createTHead(IDispatch __RPC_FAR *__RPC_FAR *head);
  virtual HRESULT STDMETHODCALLTYPE deleteTHead(void);
  virtual HRESULT STDMETHODCALLTYPE createTFoot(IDispatch __RPC_FAR *__RPC_FAR *foot);
  virtual HRESULT STDMETHODCALLTYPE deleteTFoot(void);
  virtual HRESULT STDMETHODCALLTYPE createCaption(IHTMLTableCaption __RPC_FAR *__RPC_FAR *caption);
  virtual HRESULT STDMETHODCALLTYPE deleteCaption(void);
  virtual HRESULT STDMETHODCALLTYPE insertRow(
    long index,
    IDispatch __RPC_FAR *__RPC_FAR *row);
  virtual HRESULT STDMETHODCALLTYPE deleteRow(long index = -1);
  virtual HRESULT STDMETHODCALLTYPE get_readyState(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_onreadystatechange(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_onreadystatechange(VARIANT __RPC_FAR *p);
//
// IHTMLTable2
//
  virtual HRESULT STDMETHODCALLTYPE firstPage(void);
  virtual HRESULT STDMETHODCALLTYPE lastPage(void);
        
  virtual HRESULT STDMETHODCALLTYPE get_cells(IHTMLElementCollection __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE moveRow(
    long indexFrom,
    long indexTo,
    IDispatch __RPC_FAR *__RPC_FAR *row);

};

typedef CComObject<CIHtmlTableElement> CIHtmlTableElementInstance;


class nsIDOMHTMLTableSectionElement;

class CIHtmlTableSectionElement: public CIEHtmlElement,
                                 public IDispatchImpl<IHTMLTableSection2, &IID_IHTMLTableSection2, &LIBID_MSHTML>,
                                 public IDispatchImpl<IHTMLTableSection, &IID_IHTMLTableSection, &LIBID_MSHTML>
{
public:
  CIHtmlTableSectionElement() {
  };
protected:
  virtual ~CIHtmlTableSectionElement() {
  };
  typedef nsIDOMHTMLTableSectionElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlTableSectionElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLTableSection2)
        COM_INTERFACE_ENTRY(IHTMLTableSection)
        COM_INTERFACE_ENTRY(IHTMLTableSection2)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

  virtual HRESULT STDMETHODCALLTYPE put_align(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_align(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_vAlign(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_vAlign(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_bgColor(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_bgColor(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_rows(IHTMLElementCollection __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE insertRow(
    long index,
    IDispatch __RPC_FAR *__RPC_FAR *row);
  virtual HRESULT STDMETHODCALLTYPE deleteRow(long index = -1);

//
// IHTMLTableSection2
//
  virtual HRESULT STDMETHODCALLTYPE moveRow(
    long indexFrom,
    long indexTo,
    IDispatch __RPC_FAR *__RPC_FAR *row);

};

typedef CComObject<CIHtmlTableSectionElement> CIHtmlTableSectionElementInstance;


class nsIDOMHTMLTableCaptionElement;

class CIHtmlTableCaptionElement: public CIEHtmlElement,
                                 public IDispatchImpl<IHTMLTableCaption, &IID_IHTMLTableCaption, &LIBID_MSHTML>
{
public:
  CIHtmlTableCaptionElement() {
  };
protected:
  virtual ~CIHtmlTableCaptionElement() {
  };
  typedef nsIDOMHTMLTableCaptionElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlTableCaptionElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLTableCaption)
        COM_INTERFACE_ENTRY(IHTMLTableCaption)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

  virtual HRESULT STDMETHODCALLTYPE put_align(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_align(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_vAlign(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_vAlign(BSTR __RPC_FAR *p);
};

typedef CComObject<CIHtmlTableCaptionElement> CIHtmlTableCaptionElementInstance;


class nsIDOMHTMLTableCellElement;

class CIHtmlTableCellElement: public CIEHtmlElement,
                              public IDispatchImpl<IHTMLTableCell, &IID_IHTMLTableCell, &LIBID_MSHTML>
{
public:
  CIHtmlTableCellElement() {
  };
protected:
  virtual ~CIHtmlTableCellElement() {
  };
  typedef nsIDOMHTMLTableCellElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlTableCellElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLTableCell)
        COM_INTERFACE_ENTRY(IHTMLTableCell)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

  virtual HRESULT STDMETHODCALLTYPE put_rowSpan(long p);
  virtual HRESULT STDMETHODCALLTYPE get_rowSpan(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_colSpan(long p);
  virtual HRESULT STDMETHODCALLTYPE get_colSpan(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_align(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_align(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_vAlign(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_vAlign(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_bgColor(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_bgColor(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_noWrap(VARIANT_BOOL p);
  virtual HRESULT STDMETHODCALLTYPE get_noWrap(VARIANT_BOOL __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_background(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_background(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColor(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColor(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColorLight(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColorLight(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColorDark(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColorDark(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_width(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_width(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_height(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_height(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_cellIndex(long __RPC_FAR *p);
};

typedef CComObject<CIHtmlTableCellElement> CIHtmlTableCellElementInstance;


class nsIDOMHTMLTableRowElement;

class CIHtmlTableRowElement: public CIEHtmlElement,
                             public IDispatchImpl<IHTMLTableRow, &IID_IHTMLTableRow, &LIBID_MSHTML>,
                             public IDispatchImpl<IHTMLTableRow2, &IID_IHTMLTableRow2, &LIBID_MSHTML>,
                             public IDispatchImpl<IHTMLTableRowMetrics, &IID_IHTMLTableRowMetrics, &LIBID_MSHTML>
{
public:
  CIHtmlTableRowElement() {
  };
protected:
  virtual ~CIHtmlTableRowElement() {
  };
  typedef nsIDOMHTMLTableRowElement SIB_STD_CLASSNAME;
public:

BEGIN_COM_MAP(CIHtmlTableRowElement)
        COM_INTERFACE_ENTRY_IID(IID_IDispatch, IHTMLTableRow)
        COM_INTERFACE_ENTRY(IHTMLTableRow)
        COM_INTERFACE_ENTRY(IHTMLTableRow2)
        COM_INTERFACE_ENTRY(IHTMLTableRowMetrics)
        COM_INTERFACE_ENTRY_CHAIN(CIEHtmlElement)
END_COM_MAP()

  virtual HRESULT STDMETHODCALLTYPE put_align(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_align(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_vAlign(BSTR p);
  virtual HRESULT STDMETHODCALLTYPE get_vAlign(BSTR __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_bgColor(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_bgColor(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColor(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColor(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColorLight(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColorLight(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE put_borderColorDark(VARIANT p);
  virtual HRESULT STDMETHODCALLTYPE get_borderColorDark(VARIANT __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_rowIndex(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_sectionRowIndex(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_cells(IHTMLElementCollection __RPC_FAR *__RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE insertCell(
    long index,
    IDispatch __RPC_FAR *__RPC_FAR *row);
  virtual HRESULT STDMETHODCALLTYPE deleteCell(long index = -1);

//
// IHTMLTableRow2
//

 virtual HRESULT STDMETHODCALLTYPE put_height(VARIANT p);
 virtual HRESULT STDMETHODCALLTYPE get_height(VARIANT __RPC_FAR *p);

//
// IHTMLTableRowMetrics
//

  virtual HRESULT STDMETHODCALLTYPE get_clientHeight(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_clientWidth(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_clientTop(long __RPC_FAR *p);
  virtual HRESULT STDMETHODCALLTYPE get_clientLeft(long __RPC_FAR *p);

};

typedef CComObject<CIHtmlTableRowElement> CIHtmlTableRowElementInstance;

#endif
