//
// Standard implementation for interface files
//
#ifndef _in_stdImplementation_h
#define _in_stdImplementation_h

#define SIB_STD_START(x)
//  typedef x SIB_STD_CLASSNAME ;

#define SIB_STD_END

#define SIB_STD_GET_BSTR_NOTIMPL \
{ \
  *p=NULL; \
  return E_NOTIMPL; \
}

#define SIB_STD_GET_BSTR(function) \
{ \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME *)pIDOMElement0; \
  nsString szTagName; \
  pIDOMElement->function(szTagName); \
  pIDOMElement0->Release(); \
  USES_CONVERSION; \
  *p = SysAllocString(W2COLE(szTagName.GetUnicode())); \
  return S_OK; \
}

#define SIB_STD_PUT_BSTR_NOTIMPL \
{ \
  return E_NOTIMPL; \
}

#define SIB_STD_PUT_BSTR(function) \
{ \
  if (p == NULL) { \
    return E_INVALIDARG; \
  } \
  USES_CONVERSION; \
  nsString szValue(OLE2W(p)); \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  pIDOMElement->function(szValue); \
  pIDOMElement->Release(); \
  return S_OK; \
} 


#define SIB_STD_PUT_BOOL_NOTIMPL \
{ \
  return E_NOTIMPL; \
}

#define SIB_STD_PUT_NUMERIC(function,numtype) \
{ \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  numtype nData = p; \
  pIDOMElement->function(nData); \
  pIDOMElement0->Release(); \
  return S_OK; \
}


#define SIB_STD_GET_BOOL_NOTIMPL \
{ \
  p=FALSE; \
  return E_NOTIMPL; \
}

#define SIB_STD_NOTIMPL \
{ \
  return E_NOTIMPL; \
}

#define SIB_STD_GET_NUMERIC(function,numtype) \
{ \
  if (!p) return E_INVALIDARG; \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  numtype nData; \
  pIDOMElement->function(&nData); \
  pIDOMElement0->Release(); \
  *p=nData; \
  return S_OK; \
}


#define SIB_STD_PUT_LONG_CONV(function) \
{ \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  nsString szData; szData.AppendInt(p); \
  pIDOMElement->function(szData); \
  pIDOMElement0->Release(); \
  return S_OK; \
}

#define SIB_STD_GET_LONG_CONV(function) \
{ \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  nsString szData; \
  pIDOMElement->function(szData); \
  PRInt32 error_code; \
  *p=szData.ToInteger(&error_code); \
  pIDOMElement0->Release(); \
  return S_OK; \
}

#define SIB_STD_GET_VARIANT_STR(function) \
{ \
  if (p == NULL) { \
    return E_INVALIDARG; \
  } \
  nsString szValue; \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  nsresult nr = pIDOMElement->function(szValue); \
  pIDOMElement->Release(); \
  if (nr == NS_OK) { \
    USES_CONVERSION; \
    p->vt = VT_BSTR; \
    p->bstrVal = SysAllocString(W2COLE(szValue.GetUnicode())); \
    return S_OK; \
  } else { \
    return S_FALSE; \
  } \
  return S_OK; \
}

#define SIB_STD_PUT_VARIANT_STR(function) \
{ \
  CComVariant vValue; \
  if (FAILED(vValue.ChangeType(VT_BSTR, &p))) { \
    return E_INVALIDARG; \
  } \
  nsString szValue(OLE2W(vValue.bstrVal)); \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  nsresult nr = pIDOMElement->function(szValue); \
  pIDOMElement->Release(); \
  return S_OK; \
}


#define SIB_STD_GET_FORM() \
{ \
  CIHtmlFormElementInstance *pFormInstance; \
  *p=NULL; \
  nsIDOMHTMLFormElement *pParentForm=NULL; \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  pIDOMElement->GetForm(&pParentForm); \
  pIDOMElement0->Release(); \
  if (!pParentForm) { \
    return E_UNEXPECTED; \
  } \
  CIHtmlFormElementInstance::CreateInstance(&pFormInstance); \
  if (!pFormInstance) { \
    return E_UNEXPECTED; \
  } \
  pFormInstance->SetDOMNode(pParentForm); \
  pParentForm->Release(); \
  pFormInstance->AddRef(); \
  *p=pFormInstance; \
  return S_OK; \
}

int SibTranslateCIEHTMLElement(nsIDOMNode *pNode,
                               CIEHtmlNode **pElement);

#define SIB_STD_GET_ELEMENT(interface,function,fn_elt_type) \
{ \
  CIEHtmlNode *pElementInstance = NULL; \
  fn_elt_type *pElement = NULL; \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  if (FAILED(pIDOMElement->function(&pElement))) return E_UNEXPECTED; \
  pIDOMElement->Release(); \
  nsIDOMNode *pNode = (nsIDOMNode*) pElement; \
  \
  *p=NULL; \
  if (SibTranslateCIEHTMLElement(pNode, &pElementInstance)) { \
    pElement->Release(); \
/*    pElementInstance->AddRef(); */ \
    return pElementInstance->QueryInterface(interface,(void**) p); \
  } \
  return E_OUTOFMEMORY; \
}

#define SIB_STD_GET_ELEMENT_IX(interface,function,fn_elt_type,ix) \
{ \
  CIEHtmlNode *pElementInstance = NULL; \
  fn_elt_type *pElement = NULL; \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  if (FAILED(pIDOMElement->function(ix, &pElement))) return E_UNEXPECTED; \
  pIDOMElement->Release(); \
  nsIDOMNode *pNode = (nsIDOMNode*) pElement; \
  \
  *p=NULL; \
  if (SibTranslateCIEHTMLElement(pNode, &pElementInstance)) { \
    pElement->Release(); \
/*    pElementInstance->AddRef(); */ \
    return pElementInstance->QueryInterface(interface,(void**) p); \
  } \
  return E_OUTOFMEMORY; \
}

#define SIB_STD_GET_COLLECTION(interface,function) \
{ \
  if (p == NULL) { return E_INVALIDARG;  } \
  *p = NULL; \
  CIEHtmlElementCollectionInstance *pCollection2 = NULL; \
  nsIDOMHTMLCollection *pCollection = NULL; \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  if (FAILED(pIDOMElement->function(&pCollection))) return E_UNEXPECTED; \
  pIDOMElement->Release(); \
  CIEHtmlElementCollection::CreateFromDOMHTMLCollection(pCollection, \
       (CIEHtmlElementCollection **) &pCollection2); \
  if (pCollection2) { \
    pCollection2->AddRef(); \
  } \
  pCollection->Release(); \
  return pCollection2->QueryInterface(interface,(void**)p); \
}

#define SIB_STD_VOID(function) \
{ \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  pIDOMElement->function(); \
  pIDOMElement0->Release(); \
  return S_OK; \
}

#define SIB_NODE_GET_BSTR(function) \
{ \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  nsString szTagName; \
  HRESULT rc = m_pIDOMNode->function(szTagName); \
  USES_CONVERSION; \
  *p = SysAllocString(W2COLE(szTagName.GetUnicode())); \
  return rc; \
}

#define SIB_NODE_PUT_BSTR(function) \
{ \
  if (p == NULL || m_pIDOMNode == NULL) { \
    return E_INVALIDARG; \
  } \
  USES_CONVERSION; \
  nsString szValue(OLE2W(p)); \
  return m_pIDOMNode->function(szValue); \
} 

#define SIB_NODE_PUT_NUMERIC(function,numtype) \
{ \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  numtype nData = p; \
  return m_pIDOMNode->function(nData); \
}

#define SIB_NODE_GET_NUMERIC(function,numtype) \
{ \
  if (!p) return E_INVALIDARG; \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  numtype nData; \
  HRESULT rc = m_pIDOMNode->function(&nData); \
  *p=nData; \
  return rc; \
}


#define SIB_NODE_PUT_LONG_CONV(function) \
{ \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  nsString szData; szData.AppendInt(p); \
  return m_pIDOMNode->function(szData); \
}

#define SIB_NODE_GET_LONG_CONV(function) \
{ \
  if (!p) return E_INVALIDARG; \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  nsString szData; \
  HRESULT rc = m_pIDOMNode->function(szData); \
  PRInt32 error_code; \
  *p=szData.ToInteger(&error_code); \
  return rc; \
}

#define SIB_NODE_GET_VARIANT_STR(function) \
{ \
  if (p == NULL) { \
    return E_INVALIDARG; \
  } \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  nsString szValue; \
  nsresult nr = m_pIDOMNode->function(szValue); \
  if (nr == NS_OK) { \
    USES_CONVERSION; \
    p->vt = VT_BSTR; \
    p->bstrVal = SysAllocString(W2COLE(szValue.GetUnicode())); \
    return S_OK; \
  } else { \
    return S_FALSE; \
  } \
  return S_OK; \
}

#define SIB_NODE_PUT_VARIANT_STR(function) \
{ \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  CComVariant vValue; \
  if (FAILED(vValue.ChangeType(VT_BSTR, &p))) { \
    return E_INVALIDARG; \
  } \
  nsString szValue(OLE2W(vValue.bstrVal)); \
  return m_pIDOMNode->function(szValue); \
}

int SibTranslateCIEHTMLElement(nsIDOMNode *pNode,
                               CIEHtmlNode **pElement);

#define SIB_NODE_GET_ELEMENT(function,fn_elt_type) \
{ \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  CIEHtmlNode *pElementInstance = NULL; \
  fn_elt_type *pElement = NULL; \
  if (FAILED(m_pIDOMNode->function(&pElement))) return E_UNEXPECTED; \
  nsIDOMNode *pNode = (nsIDOMNode*) pElement; \
  \
  *p=NULL; \
  if (SibTranslateCIEHTMLElement(pNode, &pElementInstance)) { \
    pElement->Release(); \
/*    pElementInstance->AddRef(); */ \
    return pElementInstance->QueryInterface(IID_IHTMLDOMNode,(void**) p); \
  } \
  return E_OUTOFMEMORY; \
}

/*

#define SIB_NODE_GET_COLLECTION(interface,function) \
{ \
  if (p == NULL) { return E_INVALIDARG;  } \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  *p = NULL; \
  CIEHtmlElementCollectionInstance *pCollection2 = NULL; \
  nsIDOMHTMLCollection *pCollection = NULL; \
  nsIDOMElement *pIDOMElement0 = nsnull; \
  SIB_STD_CLASSNAME *pIDOMElement = nsnull; \
  if (FAILED(GetDOMElement(&pIDOMElement0))) { \
    return E_UNEXPECTED; \
  } \
  pIDOMElement=(SIB_STD_CLASSNAME*)pIDOMElement0; \
  if (FAILED(pIDOMElement->function(&pCollection))) return E_UNEXPECTED; \
  pIDOMElement->Release(); \
  CIEHtmlElementCollection::CreateFromDOMHTMLCollection(pCollection, \
       (CIEHtmlElementCollection **) &pCollection2); \
  if (pCollection2) { \
    pCollection2->AddRef(); \
  } \
  pCollection->Release(); \
  return pCollection2->QueryInterface(interface,(void**)p); \
}

*/

#define SIB_NODE_VOID(function) \
{ \
  if (!m_pIDOMNode) return E_UNEXPECTED; \
  return m_pIDOMNode->function(); \
}


#endif
