#include "int\int_IHTMLFormElement.h"

#include "nsIDOMHTMLFormElement.h"
#include "nsIDOMHTMLInputElement.h"
#include "nsIDOMHTMLSelectElement.h"
#include "nsIDOMHTMLTextAreaElement.h"
#include "nsIDOMHTMLOptionElement.h"
#include "nsIDOMHTMLCollection.h"
#include "nsIDOMNSHtmlOptionCollection.h"
#include "nsIDOMHtmlFieldSetElement.h"

#include "IEHTMLElementCollection.h"
#include "IEHTMLElement.h"

#include "int\stdImplementation.h"

// -----------------------------------------------------------------------
// IHTMLFormElement
// -----------------------------------------------------------------------

SIB_STD_START(nsIDOMHTMLFormElement)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_action(BSTR p)
  SIB_STD_PUT_BSTR(SetAction)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_action(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetAction)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_encoding(BSTR p)
  SIB_STD_PUT_BSTR(SetEnctype)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_encoding(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetEnctype)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_method(BSTR p)
  SIB_STD_PUT_BSTR(SetMethod)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_method(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetMethod)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_elements(IDispatch __RPC_FAR *__RPC_FAR *p) {
  nsIDOMElement *pIDOMElement0 = nsnull;
  nsIDOMHTMLFormElement *pIDOMElement = nsnull;
  if (FAILED(GetDOMElement(&pIDOMElement0))) {
    return E_UNEXPECTED;
  }

  pIDOMElement=(nsIDOMHTMLFormElement*)pIDOMElement0;

  // Get elements
  CIEHtmlElementCollectionInstance *pCollection2 = NULL;
  nsIDOMHTMLCollection *pCollection = NULL;

  pIDOMElement->GetElements(&pCollection);
  if (!pCollection) {
    return E_UNEXPECTED;
  }

  CIEHtmlElementCollection::CreateFromDOMHTMLCollection(pCollection,
                                                       (CIEHtmlElementCollection **) &pCollection2);
  if (pCollection2) {
    pCollection2->AddRef();
  }
  pCollection->Release();
  pCollection2->QueryInterface(IID_IDispatch, (void**)p);

  return S_OK;
}

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_target(BSTR p)
  SIB_STD_PUT_BSTR(SetTarget)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_target(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetTarget)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_name(BSTR p)
  SIB_STD_PUT_BSTR(SetName)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_name(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetName)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::submit(void) {
  nsIDOMElement *pIDOMElement0 = nsnull;
  nsIDOMHTMLFormElement *pIDOMElement = nsnull;
  if (FAILED(GetDOMElement(&pIDOMElement0))) {
    return E_UNEXPECTED;
  }

  pIDOMElement=(nsIDOMHTMLFormElement*)pIDOMElement0;
  pIDOMElement->Submit();

  return S_OK;
}

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::reset(void) {
  nsIDOMElement *pIDOMElement0 = nsnull;
  nsIDOMHTMLFormElement *pIDOMElement = nsnull;
  if (FAILED(GetDOMElement(&pIDOMElement0))) {
    return E_UNEXPECTED;
  }

  pIDOMElement=(nsIDOMHTMLFormElement*)pIDOMElement0;
  pIDOMElement->Reset();

  return S_OK;
}

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_length(long __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetLength,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::item(
  VARIANT name,
  VARIANT index,
  IDispatch __RPC_FAR *__RPC_FAR *pdisp) {

  if (pdisp == NULL) {
    return E_INVALIDARG;
  }

  *pdisp = NULL;

  // Note: parameter "name" contains the index unless its a string
  //       in which case index does. Sensible huh?

  CComVariant vIndex;

  nsIDOMElement *pIDOMElement0 = nsnull;
  nsIDOMHTMLFormElement *pIDOMElement = nsnull;
  if (FAILED(GetDOMElement(&pIDOMElement0))) {
    return E_UNEXPECTED;
  }

  pIDOMElement=(nsIDOMHTMLFormElement*)pIDOMElement0;

  if (SUCCEEDED(vIndex.ChangeType(VT_I4, &name)) ||
    SUCCEEDED(vIndex.ChangeType(VT_I4, &index))) {
    // Test for stupid values
    int nIndex = vIndex.lVal;
    PRInt32 nLength;
    pIDOMElement->GetLength(&nLength);
    if (nIndex < 0 || nIndex >= nLength) {
      pIDOMElement->Release();
      return E_INVALIDARG;
    }

    nsIDOMHTMLCollection *pCollection;
    pIDOMElement->GetElements(&pCollection);
    pIDOMElement->Release();
    if (!pCollection) {
      return E_OUTOFMEMORY;
    }

    nsIDOMNode *pIDOMNode = NULL;
    pCollection->Item(nIndex,&pIDOMNode);
    pCollection->Release();
    if (!pIDOMNode) {
      return E_OUTOFMEMORY;
    }

    CIEHtmlNode *pNode = NULL;

    if (SibTranslateCIEHTMLElement(pIDOMNode, &pNode)) {
//      pNode->AddRef();
      return pNode->GetIDispatch(pdisp);
    } else return E_OUTOFMEMORY;

  } else if (SUCCEEDED(vIndex.ChangeType(VT_BSTR, &index))) {
    // If this parameter contains a string, the method returns
    // a collection of objects, where the value of the name or
    // id property for each object is equal to the string.

    // TODO all of the above!
     return E_NOTIMPL;
  } else {
    return E_INVALIDARG;
  }

  return S_OK;
}

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_acceptCharset(BSTR p)
  SIB_STD_PUT_BSTR(SetAcceptCharset)

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_acceptCharset(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetAcceptCharset)

//
// --- Not implemented
//
HRESULT STDMETHODCALLTYPE CIHtmlFormElement::urns(
  VARIANT urn,
  IDispatch __RPC_FAR *__RPC_FAR *pdisp) {

  *pdisp=NULL;
  return E_NOTIMPL;

}

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::tags(
  VARIANT tagName,
  IDispatch __RPC_FAR *__RPC_FAR *pdisp) {

  *pdisp=NULL;
  return E_NOTIMPL;
}

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get__newEnum(IUnknown __RPC_FAR *__RPC_FAR *p) {
  *p=NULL;
  return E_NOTIMPL;
}

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_length(long p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_onsubmit(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_onsubmit(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_onreset(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_onreset(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::put_dir(BSTR p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlFormElement::get_dir(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR_NOTIMPL


SIB_STD_END

// -----------------------------------------------------------------------
// IHTMLInputElement
// -----------------------------------------------------------------------

SIB_STD_START(nsIDOMHTMLInputElement)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_type(BSTR p)
  SIB_STD_PUT_BSTR(SetType)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_type(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetType)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_value(BSTR p)
  SIB_STD_PUT_BSTR(SetValue)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_value(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetValue)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_name(BSTR p)
  SIB_STD_PUT_BSTR(SetName)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_name(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetName)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_disabled(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetDisabled,PRBool)  

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_disabled(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetDisabled,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_form(IHTMLFormElement __RPC_FAR *__RPC_FAR *p)
  SIB_STD_GET_FORM()

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_size(long p)
  SIB_STD_PUT_LONG_CONV(SetSize)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_size(long __RPC_FAR *p)
  SIB_STD_GET_LONG_CONV(GetSize)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_maxLength(long p)
  SIB_STD_PUT_NUMERIC(SetMaxLength,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_maxLength(long __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetMaxLength,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::select(void) {
  nsIDOMElement *pIDOMElement0 = nsnull;
  nsIDOMHTMLInputElement *pIDOMElement = nsnull;
  if (FAILED(GetDOMElement(&pIDOMElement0))) {
    return E_UNEXPECTED;
  }

  pIDOMElement=(nsIDOMHTMLInputElement*)pIDOMElement0;
  pIDOMElement->Select();

  return S_OK;
}

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_defaultValue(BSTR p)
  SIB_STD_PUT_BSTR(SetDefaultValue)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_defaultValue(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetDefaultValue)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_readOnly(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetReadOnly,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_readOnly(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetReadOnly,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_defaultChecked(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetDefaultChecked,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_defaultChecked(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetDefaultChecked,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_checked(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetChecked,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_checked(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetChecked,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_alt(BSTR p)
  SIB_STD_PUT_BSTR(SetAlt)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_alt(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetAlt)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_src(BSTR p)
  SIB_STD_PUT_BSTR(SetSrc)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_src(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetSrc)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_align(BSTR p)
  SIB_STD_PUT_BSTR(SetAlign)

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_align(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetAlign)

//
// --- Not implemented
//
HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_width(long p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_width(long __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_height(long p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_height(long __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_start(BSTR p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_start(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_lowsrc(BSTR p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_lowsrc(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_vrml(BSTR p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_vrml(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_dynsrc(BSTR p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_dynsrc(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_readyState(BSTR __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_complete(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_loop(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_loop(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::createTextRange(IHTMLTxtRange __RPC_FAR *__RPC_FAR *range)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_indeterminate(VARIANT_BOOL p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_indeterminate(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_BOOL_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_onchange(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_onchange(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_onselect(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_onselect(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_onload(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_onload(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_onerror(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_onerror(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_onabort(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_onabort(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_status(VARIANT_BOOL p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_status(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_vspace(long p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_vspace(long __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_hspace(long p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_hspace(long __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_border(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_border(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

//
// Element-specific calls
//
// *Button *Hidden *Text *File
HRESULT STDMETHODCALLTYPE CIHtmlInputElement::put_status(VARIANT p)
  SIB_STD_NOTIMPL

// *Button *Hidden *Text *File
HRESULT STDMETHODCALLTYPE CIHtmlInputElement::get_status(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

SIB_STD_END

// -----------------------------------------------------------------------
// CIHtmlSelectElement
// -----------------------------------------------------------------------

SIB_STD_START(nsIDOMHTMLSelectElement)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::put_size(long p)
  SIB_STD_PUT_NUMERIC(SetSize,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_size(long __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetSize,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::put_multiple(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetMultiple,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_multiple(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetMultiple,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::put_name(BSTR p)
  SIB_STD_PUT_BSTR(SetName)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_name(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetName)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_options(IDispatch __RPC_FAR *__RPC_FAR *p)
  //
  // TODO!!
  //
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::put_onchange(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_onchange(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::put_selectedIndex(long p)
  SIB_STD_PUT_NUMERIC(SetSelectedIndex,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_selectedIndex(long __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetSelectedIndex,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_type(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetType)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::put_value(BSTR p)
  SIB_STD_PUT_BSTR(SetValue)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_value(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetValue)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::put_disabled(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetDisabled,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_disabled(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetDisabled,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_form(IHTMLFormElement __RPC_FAR *__RPC_FAR *p)
  SIB_STD_GET_FORM()

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::add(
    IHTMLElement __RPC_FAR *element,
    VARIANT before)
  //
  // TODO!
  //
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::remove(long p)
  SIB_STD_PUT_NUMERIC(Remove,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::put_length(long p)
  SIB_STD_PUT_NUMERIC(SetLength,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get_length(long __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetLength,PRUint32)

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::get__newEnum(IUnknown __RPC_FAR *__RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::item(
    VARIANT name,
    VARIANT index,
    IDispatch __RPC_FAR *__RPC_FAR *pdisp)
{
  if (pdisp == NULL) {
    return E_INVALIDARG;
  }

  *pdisp = NULL;

  // Note: parameter "name" contains the index unless its a string
  //       in which case index does. Sensible huh?

  CComVariant vIndex;

  nsIDOMElement *pIDOMElement0 = nsnull;
  nsIDOMHTMLSelectElement *pIDOMElement = nsnull;
  if (FAILED(GetDOMElement(&pIDOMElement0))) {
    return E_UNEXPECTED;
  }

  pIDOMElement=(nsIDOMHTMLSelectElement*)pIDOMElement0;

  if (SUCCEEDED(vIndex.ChangeType(VT_I4, &name)) ||
    SUCCEEDED(vIndex.ChangeType(VT_I4, &index))) {
    // Test for stupid values
    int nIndex = vIndex.lVal;
    PRUint32 nLength;
    pIDOMElement->GetLength(&nLength);
    if (nIndex < 0 || nIndex >= nLength) {
      pIDOMElement->Release();
      return E_INVALIDARG;
    }

    nsIDOMNSHTMLOptionCollection *pCollection;
    pIDOMElement->GetOptions(&pCollection);
    pIDOMElement->Release();
    if (!pCollection) {
      return E_OUTOFMEMORY;
    }

    nsIDOMNode *pIDOMNode = NULL;
    pCollection->Item(nIndex,&pIDOMNode);
    pCollection->Release();
    if (!pIDOMNode) {
      return E_OUTOFMEMORY;
    }

    CIEHtmlNode *pNode = NULL;

    if (SibTranslateCIEHTMLElement(pIDOMNode, &pNode)) {
//      pNode->AddRef();
      return pNode->GetIDispatch(pdisp);
    } else return E_OUTOFMEMORY;

  } else if (SUCCEEDED(vIndex.ChangeType(VT_BSTR, &index))) {
    // If this parameter contains a string, the method returns
    // a collection of objects, where the value of the name or
    // id property for each object is equal to the string.

    // TODO all of the above!
     return E_NOTIMPL;
  } else {
    return E_INVALIDARG;
  }

  return S_OK;
}

HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::tags(
    VARIANT tagName,
    IDispatch __RPC_FAR *__RPC_FAR *pdisp)
  //
  // TODO!
  //
  SIB_STD_NOTIMPL

//
// IHTMLSelectElement2
//
HRESULT STDMETHODCALLTYPE CIHtmlSelectElement::urns(
     VARIANT urn,
     IDispatch __RPC_FAR *__RPC_FAR *pdisp)
  //
  // TODO!
  //
  SIB_STD_NOTIMPL

SIB_STD_END

// -----------------------------------------------------------------------
// CIHtmlTextAreaElement
// -----------------------------------------------------------------------

SIB_STD_START(nsIDOMHTMLTextAreaElement)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_type(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetType)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_value(BSTR p)
  SIB_STD_PUT_BSTR(SetValue)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_value(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetValue)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_name(BSTR p)
  SIB_STD_PUT_BSTR(SetName)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_name(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetName)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_status(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_status(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_disabled(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetDisabled,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_disabled(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetDisabled,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_form(IHTMLFormElement __RPC_FAR *__RPC_FAR *p)
  SIB_STD_GET_FORM()

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_defaultValue(BSTR p)
  SIB_STD_PUT_BSTR(SetDefaultValue)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_defaultValue(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetDefaultValue)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::select(void) {
  nsIDOMElement *pIDOMElement0 = nsnull;
  nsIDOMHTMLTextAreaElement *pIDOMElement = nsnull;
  if (FAILED(GetDOMElement(&pIDOMElement0))) {
    return E_UNEXPECTED;
  }

  pIDOMElement=(nsIDOMHTMLTextAreaElement*)pIDOMElement0;

  // Set the attribute
  pIDOMElement->Select();
  pIDOMElement->Release();

  return S_OK;
}

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_onchange(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_onchange(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_onselect(VARIANT p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_onselect(VARIANT __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_readOnly(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetReadOnly,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_readOnly(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetReadOnly,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_rows(long p)
  SIB_STD_PUT_NUMERIC(SetRows,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_rows(long __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetRows,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_cols(long p)
  SIB_STD_PUT_NUMERIC(SetCols,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_cols(long __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetCols,PRInt32)

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::put_wrap(BSTR p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::get_wrap(BSTR __RPC_FAR *p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlTextAreaElement::createTextRange(IHTMLTxtRange __RPC_FAR *__RPC_FAR *range)
  SIB_STD_NOTIMPL

SIB_STD_END

// -----------------------------------------------------------------------
// CIHtmlOptionElement::
// -----------------------------------------------------------------------

SIB_STD_START(nsIDOMHTMLOptionElement)

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::put_selected(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetSelected,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::get_selected(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetSelected,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::put_value(BSTR p)
  SIB_STD_PUT_BSTR(SetValue)

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::get_value(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetValue)

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::put_defaultSelected(VARIANT_BOOL p)
  SIB_STD_PUT_NUMERIC(SetDefaultSelected,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::get_defaultSelected(VARIANT_BOOL __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetDefaultSelected,PRBool)

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::put_index(long p)
  SIB_STD_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::get_index(long __RPC_FAR *p)
  SIB_STD_GET_NUMERIC(GetIndex,PRInt32)
  
HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::put_text(BSTR p)
  SIB_STD_PUT_BSTR(SetText)

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::get_text(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR(GetText)

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::get_form(IHTMLFormElement __RPC_FAR *__RPC_FAR *p)
  SIB_STD_GET_FORM()

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::get_innerText(BSTR __RPC_FAR *p) {
  nsIDOMElement *pIDOMElement0 = nsnull;
  nsIDOMHTMLOptionElement *pIDOMElement = nsnull;
  if (FAILED(GetDOMElement(&pIDOMElement0))) {
    return E_UNEXPECTED;
  }

  pIDOMElement=(nsIDOMHTMLOptionElement*)pIDOMElement0;
  nsString szData;
  pIDOMElement->GetLabel(szData);
  pIDOMElement0->Release();

  USES_CONVERSION;
  *p = SysAllocString(W2COLE(szData.GetUnicode()));
  return S_OK;
}

HRESULT STDMETHODCALLTYPE CIHtmlOptionElement::get_outerText(BSTR __RPC_FAR *p) {
  return get_innerText(p);
}

//------------------------------------------------------------------------
// CIHtmlFieldSetElement
//------------------------------------------------------------------------
HRESULT STDMETHODCALLTYPE CIHtmlFieldSetElement::put_align(BSTR p)
  SIB_STD_GET_BSTR_NOTIMPL

HRESULT STDMETHODCALLTYPE CIHtmlFieldSetElement::get_align(BSTR __RPC_FAR *p)
  SIB_STD_GET_BSTR_NOTIMPL


// ************************************************
// ************************************************
// ************************************************

HRESULT WINAPI Sib_InputTypeFunc(void* pv, REFIID riid, LPVOID* ppv, DWORD dw) {
  nsString szType;
  nsIDOMElement *pIDOMElement0 = nsnull;
  nsIDOMHTMLInputElement *pIDOMElement = nsnull;
  if (FAILED(((CIHtmlInputElement*)pv)->GetDOMElement(&pIDOMElement0))) {
    return E_UNEXPECTED;
  }

  pIDOMElement=(nsIDOMHTMLInputElement*)pIDOMElement0;
  nsString szData;
  pIDOMElement->GetType(szType);
  pIDOMElement0->Release();
  *ppv=NULL;

  if (szType.EqualsIgnoreCase("BUTTON")) return (dw==0) ? S_FALSE : E_NOINTERFACE;
  if (szType.EqualsIgnoreCase("HIDDEN")) return (dw==1) ? S_FALSE : E_NOINTERFACE;
  if (szType.EqualsIgnoreCase("FILE"))   return (dw==3) ? S_FALSE : E_NOINTERFACE;
  if (szType.EqualsIgnoreCase("RADIO"))  return (dw==4) ? S_FALSE : E_NOINTERFACE;
  if (szType.EqualsIgnoreCase("IMAGE"))  return (dw==5) ? S_FALSE : E_NOINTERFACE;
  if (szType.EqualsIgnoreCase("SUBMIT")) return E_NOINTERFACE;
  if (szType.EqualsIgnoreCase("RESET")) return E_NOINTERFACE;
  if (dw==2) // Text - the default.
    return S_FALSE;
  return E_NOINTERFACE;
}
