#include "plstr.h"

#include "nsRFProxy.h"
#include "nsMemory.h"
#include "nsIDocument.h"

#include "filler.h"
#include "MozillaControl.h"

const IID LIBID_MOZILLACONTROLLib = {0x1339B53E,0x3453,0x11D2,{0x93,0xB9,0x00,0x00,0x00,0x00,0x00,0x00}};
const IID IID_IMozCtlConnect = {0x372805C1,0xC0AF,0x11D4,{0xA3,0xFE,0x00,0x00,0x00,0x00,0x00,0x00}};
const CLSID CLSID_MozCtlConnect = {0x372805C2,0xC0AF,0x11D4,{0xA3,0xFE,0x00,0x00,0x00,0x00,0x00,0x00}};
const IID LIBID_ROBOFORMLib = {0xBAAC3901,0x6642,0x11D3,{0xAB,0xEE,0xC5,0xDB,0xF3,0x57,0x1F,0x46}};
const IID IID_IFormFiller = {0xE66C0C8E,0x84EE,0x11D3,{0xAB,0xEE,0xDD,0x01,0xD0,0xA6,0x18,0x4B}};
const CLSID CLSID_FormFiller = {0x3AB6A2BE,0x5A44,0x11D3,{0xAB,0xEE,0xEA,0xF4,0x5F,0x64,0x34,0x46}};
const CLSID CLSID_ToolBand = {0x724D43A0,0x0D85,0x11D4,{0x99,0x08,0x00,0x40,0x05,0x23,0xE3,0x9A}};
const CLSID CLSID_ExplorerBar = {0x724D43A8,0x0D85,0x11D4,{0x99,0x08,0x00,0x40,0x05,0x23,0xE3,0x9A}};
const CLSID CLSID_BrowserHelper = {0x724D43A9,0x0D85,0x11D4,{0x99,0x08,0x00,0x40,0x05,0x23,0xE3,0x9A}};

#include <atlbase.h>
//#include <atlctl.h>
//#include <exdisp.h>
//#include <mshtml.h>

////////////////////////////////////////////////////////////////////////

nsRFProxyImpl::nsRFProxyImpl() {
  NS_INIT_REFCNT();
  //
  // Magic call to prevent Netscape from coredump. Strange, heh?
  //
  OleUninitialize();
}

nsRFProxyImpl::~nsRFProxyImpl() {
}

NS_IMPL_ISUPPORTS1(nsRFProxyImpl, nsIRFProxy);

NS_IMETHODIMP nsRFProxyImpl::DoSetup() {

  HRESULT hr;

  CComPtr<IFormFiller> pFiller;
  hr = CoCreateInstance(CLSID_FormFiller,
                        NULL,
                        CLSCTX_INPROC_SERVER,
                        IID_IFormFiller,
                        (void**)&pFiller);
  NS_ASSERTION(hr==0,"Cannot initialize FormFiller");

  pFiller->RunSetup();

  return NS_OK;

}

NS_IMETHODIMP nsRFProxyImpl::FillFormsIn(nsISupports * aValue) {

  HRESULT hr;

  CComPtr<IMozCtlConnect> pConnector;
  hr = CoCreateInstance(CLSID_MozCtlConnect,
                        NULL,
                        CLSCTX_INPROC_SERVER,
                        IID_IMozCtlConnect,
                        (void**)&pConnector);
  NS_ASSERTION(hr==0,"Cannot initialize MozCtlConnect");

  CComPtr<IFormFiller> pFiller;
  hr = CoCreateInstance(CLSID_FormFiller,
                        NULL,
                        CLSCTX_INPROC_SERVER,
                        IID_IFormFiller,
                        (void**)&pFiller);
  NS_ASSERTION(hr==0,"Cannot initialize FormFiller");

  CComPtr<IDispatch> cpDispDocument;
  pConnector->Connect((void*)aValue,&cpDispDocument);
  if (cpDispDocument == NULL) {
    return NS_OK;
  }

  pFiller->FillForms(cpDispDocument);

  return NS_OK;

}

NS_IMETHODIMP nsRFProxyImpl::CheckFormsIn(nsISupports * aValue) {

  HRESULT hr;

  CComPtr<IMozCtlConnect> pConnector;
  hr = CoCreateInstance(CLSID_MozCtlConnect,
                        NULL,
                        CLSCTX_INPROC_SERVER,
                        IID_IMozCtlConnect,
                        (void**)&pConnector);
  NS_ASSERTION(hr==0,"Cannot initialize MozCtlConnect");

  CComPtr<IFormFiller> pFiller;
  hr = CoCreateInstance(CLSID_FormFiller,
                        NULL,
                        CLSCTX_INPROC_SERVER,
                        IID_IFormFiller,
                        (void**)&pFiller);
  NS_ASSERTION(hr==0,"Cannot initialize FormFiller");

  CComPtr<IDispatch> cpDispDocument;
  pConnector->Connect((void*)aValue,&cpDispDocument);
  if (cpDispDocument == NULL) {
    return NS_OK;
  }

  pFiller->FillForms(cpDispDocument);

  return NS_OK;

}

NS_IMETHODIMP nsRFProxyImpl::MemorizePbeIn(nsISupports * aValue) {

  HRESULT hr;

  CComPtr<IMozCtlConnect> pConnector;
  hr = CoCreateInstance(CLSID_MozCtlConnect,
                        NULL,
                        CLSCTX_INPROC_SERVER,
                        IID_IMozCtlConnect,
                        (void**)&pConnector);
  NS_ASSERTION(hr==0,"Cannot initialize MozCtlConnect");

  CComPtr<IFormFiller> pFiller;
  hr = CoCreateInstance(CLSID_FormFiller,
                        NULL,
                        CLSCTX_INPROC_SERVER,
                        IID_IFormFiller,
                        (void**)&pFiller);
  NS_ASSERTION(hr==0,"Cannot initialize FormFiller");

  CComPtr<IDispatch> cpDispDocument;
  pConnector->Connect((void*)aValue,&cpDispDocument);
  if (cpDispDocument == NULL) {
    return NS_OK;
  }

  pFiller->FillForms(cpDispDocument);

  return NS_OK;

}

NS_IMETHODIMP nsRFProxyImpl::FillPbeIn(nsISupports * aValue) {

  HRESULT hr;

  CComPtr<IMozCtlConnect> pConnector;
  hr = CoCreateInstance(CLSID_MozCtlConnect,
                        NULL,
                        CLSCTX_INPROC_SERVER,
                        IID_IMozCtlConnect,
                        (void**)&pConnector);
  NS_ASSERTION(hr==0,"Cannot initialize MozCtlConnect");

  CComPtr<IFormFiller> pFiller;
  hr = CoCreateInstance(CLSID_FormFiller,
                        NULL,
                        CLSCTX_INPROC_SERVER,
                        IID_IFormFiller,
                        (void**)&pFiller);
  NS_ASSERTION(hr==0,"Cannot initialize FormFiller");

  CComPtr<IDispatch> cpDispDocument;
  pConnector->Connect((void*)aValue,&cpDispDocument);
  if (cpDispDocument == NULL) {
    return NS_OK;
  }

  pFiller->FillForms(cpDispDocument);

  return NS_OK;

}

