#include "nsIRFProxy.h"

/**
 * SampleImpl is an implementation of the nsISample interface.  In XPCOM,
 * there can be more than one implementation of an given interface.  Class
 * IDs (CIDs) uniquely identify a particular implementation of an interface.
 * Interface IDs (IIDs) uniquely identify an interface.
 *
 * The CID is also a unique number that looks just like an IID
 * and uniquely identifies an implementation
 * {64998110-C344-11d4-A405-000000000000}
 */

#define NS_RFPROXY_CID \
{ 0x64998110, 0xc344, 0x11d4, { 0xa4, 0x5, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } }

#define NS_RFPROXY_CONTRACTID "@mozilla.org/rfproxy;1"

class nsRFProxyImpl : public nsIRFProxy
{
public:
    nsRFProxyImpl();
    virtual ~nsRFProxyImpl();

    NS_DECL_ISUPPORTS
    NS_DECL_NSIRFPROXY

};
