#include "nsIGenericFactory.h"

#include "nsRFproxy.h"

////////////////////////////////////////////////////////////////////////
// NOTE this file supercedes nsSampleFactory.cpp.  nsSampleFactory has
// extensive comments, but it has been CVS removed to reduce clutter
// in this sample.  It's available to the interested via CVS history:
// cvs up nsSampleFactory.cpp -r 1.10
////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
// With the below sample, you can define an implementation glue
// that talks with xpcom for creation of component nsSampleImpl
// that implement the interface nsISample. This can be extended for
// any number of components.
////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
// Define the contructor function for the object nsRFProxyImpl
//
// What this does is defines a function nsSampleImplConstructor which we
// will specific in the nsModuleComponentInfo table. This function will
// be used by the generic factory to create an instance of nsSampleImpl.
//
// NOTE: This creates an instance of nsRFProxyImpl by using the default
//               constructor nsRFProxyImpl::nsRFProxyImpl()
//
NS_GENERIC_FACTORY_CONSTRUCTOR(nsRFProxyImpl)

////////////////////////////////////////////////////////////////////////
// Define a table of CIDs implemented by this module along with other
// information like the function to create an instance, contractid, and
// class name.
//
// The Registration and Unregistration proc are optional in the structure.
//
static NS_METHOD nsRFProxyRegistrationProc(nsIComponentManager *aCompMgr,
                                           nsIFile *aPath,
                                           const char *registryLocation,
                                           const char *componentType)
{
    // Do any registration specific activity like adding yourself to a
    // category. The Generic Module will take care of registering your
    // component with xpcom. You dont need to do that. Only any component
    // specific additional activity needs to be done here.

    // This functions is optional. If you dont need it, dont add it to the structure.

    return NS_OK;
}

static NS_METHOD nsRFProxyUnregistrationProc(nsIComponentManager *aCompMgr,
                                             nsIFile *aPath,
                                             const char *registryLocation)
{
    // Undo any component specific registration like adding yourself to a
    // category here. The Generic Module will take care of unregistering your
    // component from xpcom. You dont need to do that. Only any component
    // specific additional activity needs to be done here.

    // This functions is optional. If you dont need it, dont add it to the structure.

    // Return value is not used from this function.
    return NS_OK;
}

static nsModuleComponentInfo components[] =
{
  { "Sample Component", NS_RFPROXY_CID, NS_RFPROXY_CONTRACTID, nsRFProxyImplConstructor,
    nsRFProxyRegistrationProc /* NULL if you dont need one */,
    nsRFProxyUnregistrationProc /* NULL if you dont need one */
  }
};

////////////////////////////////////////////////////////////////////////
// Implement the NSGetModule() exported function for your module
// and the entire implementation of the module object.
//
// NOTE: If you want to use the module shutdown to release any
//              module specific resources, use the macro
//              NS_IMPL_NSGETMODULE_WITH_DTOR() instead of the vanilla
//              NS_IMPL_NSGETMODULE()
//
NS_IMPL_NSGETMODULE("nsRFproxyModule", components)
